import java.util.Random;

// This class, when invoked, assigns values to 
// the variables header, terminal, terminal2 and nonTerm.
// These are used by class SamGrammar to fill an array
// of 20 rules. 

public class SamRule
{
	private String terminal;
	private String termIn;
	private String terminal2;
	private String termIn2;

	
	public SamRule()
	{
		setTerminal();
		setTerminal2();
		getTerminal();
		getTerminal2();
	}
	
	public String[][] endRuleA(String[][] endrulea, int a)
	{		
		setTerminal2();
		endrulea[a][0] = "sam_expre_" + termIn2;
		endrulea[a][1] = " ";
		endrulea[a][2] = getTerminal2();
		endrulea[a][3] = " ";
		
		return endrulea;
	}
	
	public String[][] endRuleB(String[][] endruleb, int b)
	{
		setTerminal();
		setTerminal2();
		endruleb[b][0] = "sam_expre_" + termIn;
		endruleb[b][1] = getTerminal();
		endruleb[b][2] = getTerminal2();
		endruleb[b][3] = " ";
		
		return endruleb;
	}
	
	public String[][] conRule(String[][] conrule, int c)
	{	
		setTerminal();
		setTerminal2();
		conrule[c][0] = "sam_expre_" + termIn;
		conrule[c][1] = getTerminal();
		conrule[c][2] = getTerminal2();
		conrule[c][3] = "sam_expre_" + termIn2;
		
		return conrule;
	}
	
	public String[][] startRule(String[][] startrule, int s)
	{
		setTerminal2();
		startrule[s][0] = "start";
		startrule[s][1] = " ";
		startrule[s][2] = getTerminal2();
		startrule[s][3] = "sam_expre_" + termIn2;
		
		return startrule;
	}
	
	public int isEqual(String[][] equalrule, int e, int f)
	{
	   
		if ((equalrule[e][0].equals(equalrule[f][0])) && (equalrule[e][1].equals(equalrule[f][1])) && 
			(equalrule[e][2].equals(equalrule[f][2])) && (equalrule[e][3].equals(equalrule[f][3]))){
			return 1;
		} else 
			return 0;
	}
	
	public int existPath(String[][] equalrule, int g, int h)
	{
		if ((g != h) && (equalrule[g][0].equals(equalrule[h][3]))){
			return 1;
		} else 
			return 0;
	}
	
	public String getTerminal()
	{
		return terminal;
	}
	
	public String getTermIn()
	{
		return termIn;
	}
	
	public String getTerminal2()
	{
		return terminal2;
	}
	
	public String getTermIn2()
	{
		return termIn2;
	}
	
	public void setTerminal()
	{
	// A method invoking the methods that 
	// select the terminal and termIn
		Random generator = new Random();
		int anumB = generator.nextInt(5);
		terminal = selTerminal(anumB);
		termIn = selTermIn(anumB);
	}
	
	public void setTerminal2()
	{
	// A method invoking the methods that 
	// select the terminal and termIn
		Random generator = new Random();
		int dnumB = generator.nextInt(5);
		terminal2 = selTerminal2(dnumB);
		termIn2 = selTermIn2(dnumB);
	}
	
	
	public String selTerminal(int bnumB)
	{
	// A method selecting terminal 	
		switch (bnumB)
		{ 
			case 0:  
		    	return "DEFINITE";
			case 1:  
		    	return "COMPLEX";
			case 2: 
		    	return "VARIABLE";
		    case 3: 
		    	return "UNPREDICTABLE";
			case 4: 
		    	return "HELD_UF";
		    default:
		    	return "Error";
		}
	}
	
	public String selTermIn(int cnumB)
	{
	// A method selecting the terminal initials
		switch (cnumB)
		{ 
			case 0:  
		    	return "d";
			case 1:  
		    	return "c";
			case 2: 
		    	return "v";
		    case 3: 
		    	return "u";
			case 4: 
				return "hu";
		    default:
		    	return "Error";
		}
	}
	
	public String selTerminal2(int enumB)
	{
	// Similar for terminal2	
		switch (enumB)
		{ 
			case 0:  
		    	return "DEFINITE";
			case 1:  
		    	return "COMPLEX";
			case 2: 
		    	return "VARIABLE";
		    case 3: 
		    	return "UNPREDICTABLE";
			case 4: 
		    	return "HELD_UF";
		    default:
		    	return "Error";
		}
	}
	
	public String selTermIn2(int fnumB)
	{
	// Similar for the terminal2 initials
		switch (fnumB)
		{ 
			case 0:  
		    	return "d";
			case 1:  
		    	return "c";
			case 2: 
		    	return "v";
		    case 3: 
		    	return "u";
			case 4: 
				return "hu";
		    default:
		    	return "Error";
		}
	}
}