import java.util.Random;
import java.util.ArrayList;
import java.util.Scanner;
import com.cycling74.max.*;

public class RhhRuleM extends MaxObject
{
	int response = 0;
	int end_a = 2;
    int end_b = 2;
    int contin = 14;
    int start = 2;
    
    String[][] rule;
    int[] stops;
    
	public void list(int[] args)
  	{
  		declareInlets(new int[]{ DataTypes.ALL, DataTypes.ALL});
  		declareOutlets(new int[]{ DataTypes.ALL, DataTypes.ALL});
  		
  		post ("Creating new rule set!");
  		
  		int end_a = args[0];
    	int end_b = args[1];
    	int contin = args[2];
    	int start = args[3];
  		
  		rule = new String[end_a + end_b + contin + start][4];
    	
    	// Establish the ranges for each type of rule.
    	stops = new int[4];
    	// 0-stops[0] are end_a rules
    	stops[0]=end_a;
    	// stops[0]-stops[1] are end_b rules
    	stops[1]=stops[0] + end_b;
   	 	// stops[1]-stops[2] are contin rules
    	stops[2]=stops[1] + contin;
    	// stops[2]-stops[3] are start rules
    	stops[3]=stops[2] + start;
    	
    	RhhRuleSet setArule = new RhhRuleSet(rule, stops, end_a, end_b, contin, start);
    	setArule.printRule(rule, stops);
    }
    
    public void bang ()
    {
    	declareInlets(new int[]{ DataTypes.ALL, DataTypes.ALL});
    	declareOutlets(new int[]{ DataTypes.ALL, DataTypes.ALL});
     
     	ArrayList<String> pathA = new ArrayList<String>(20);
    	RhhPath setApath = new RhhPath();
    		
    	setApath.generatePath(pathA, rule);
    	
    	for (String entry : pathA)
			outlet(0, entry);
    }   
}