import java.util.Random;

// This class, when invoked, assigns values to 
// the variables header, terminal, terminal2 and nonTerm.
// These are used by class BalGrammar to fill an array
// of 20 rules. 

public class STabRule
{
	private String terminal;
	private String termIn;
	private String termIn2;
	
	
	public STabRule()
	{
		setTerminal();
		setTermIn();
		setTermIn2();		
		getTerminal();
		getTermIn();
		getTermIn2();

	}
	
	public String[][] endRuleA(String[][] endrulea, int a)
	{		
		setTerminal();
		setTermIn2();
		endrulea[a][0] = "stab_expre_" + termIn2;
		endrulea[a][1] = getTerminal();
		endrulea[a][2] = " ";
		
		return endrulea;
	}
	
	
	public String[][] conRule(String[][] conrule, int c)
	{	
		setTerminal();
		setTermIn();
		setTermIn2();
		conrule[c][0] = "stab_expre_" + termIn;
		conrule[c][1] = getTerminal();
		conrule[c][2] = "stab_expre_" + termIn2;
		
		return conrule;
	}
	
	public String[][] startRule(String[][] startrule, int s)
	{
		setTerminal();
		setTermIn();
		setTermIn2();
		startrule[s][0] = "start";
		startrule[s][1] = getTerminal();
		startrule[s][2] = "stab_expre_" + termIn2;
		
		return startrule;
	}
	
	public int isEqual(String[][] equalrule, int e, int f)
	{
	    
		if ((equalrule[e][0].equals(equalrule[f][0])) && (equalrule[e][1].equals(equalrule[f][1])) && 
			(equalrule[e][2].equals(equalrule[f][2]))){
			return 1;
		} else 
			return 0;
	}
	
	public int existPath(String[][] equalrule, int g, int h)
	{
		if ((g != h) && (equalrule[g][0].equals(equalrule[h][2]))){
			return 1;
		} else 
			return 0;
	}
	
	public String getTerminal()
	{
		return terminal;
	}
	
	public String getTermIn()
	{
		return termIn;
	}
	
	public String getTermIn2()
	{
		return termIn2;
	}
		
	public void setTerminal()
	{
	// A method invoking the methods that 
	// select the terminal and termIn
		Random generator = new Random();
		int anumB = generator.nextInt(3);
		terminal = selTerminal(anumB);
	}
	
	public void setTermIn()
	{
		Random generator = new Random();
		int aanumB = generator.nextInt(3);
		termIn = selTermIn(aanumB);
	}
	
	public void setTermIn2()
	{
		Random generator = new Random();
		int dnumB = generator.nextInt(3);
		termIn2 = selTermIn2(dnumB);
	}
	
	
	public String selTerminal(int bnumB)
	{
	// A method selecting terminal 	
		switch (bnumB)
		{ 
			case 0:  
		    	return "ACCUMULATION";
			case 1:  
		    	return "SAMPLE";
			case 2: 
		    	return "EXCENTRIC";
		    default:
		    	return "Error";
		}
	}
	
	public String selTermIn(int cnumB)
	{
	// A method selecting the terminal initials
		switch (cnumB)
		{ 
			case 0:  
		    	return "acc";
			case 1:  
		    	return "sam";
			case 2: 
				return "exc";
		    default:
		    	return "Error";
		}
	}
	
	
	public String selTermIn2(int fnumB)
	{
	// Similar for the terminal2 initials
		switch (fnumB)
		{ 
			case 0:  
		    	return "acc";
			case 1:  
		    	return "sam";
			case 2: 
				return "exc";
		    default:
		    	return "Error";
		}
	}
	
}